#include <WiFi.h>
#include <ESPAsyncWebSrv.h>

//需要在""内进行配网
const char* ssid = "ChinaNet-JTKB"; //WIFI的名称
const char* password = "a3w54htk"; //WIFI的密码

int ledPin = 10;  // 设置用于控制 LED 的引脚

AsyncWebServer server(80);

void setup() {
  Serial.begin(115200);  //配置串口波特率
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);
  
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi...");
  }
  Serial.println("Connected to WiFi");

  // server.on("./img/pic_bulboff.gif", HTTP_GET, [](AsyncWebServerRequest *request) {
  //   request->send(SPIFFS, "./img/pic_bulbon.gif", "image/png");
  // });

  // server.on("./img/pic_bulbon.gif", HTTP_GET, [](AsyncWebServerRequest *request) {
  //   request->send(SPIFFS, "./img/pic_bulbon.gif", "image/png");
  // });
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    String html = "<html><body>";
    html += "<h1>ESP32 LED Control</h1>";
    html += "<p>LED Status: <span id='ledStatus'></span></p>";
    html += "<img id='myimage' src='https://www.runoob.com/images/pic_bulboff.gif' width='100' height='180'>";
    html += "<button onclick='toggleLED()'>Toggle LED</button>";
    html += "<script>function toggleLED() {"
            "var statusElement = document.getElementById('ledStatus');"
            "var xhr = new XMLHttpRequest();"
            "xhr.open('GET', '/toggle', true);"
            "xhr.send();"
            "element=document.getElementById('myimage');"
            "if(element.src.match('bulbon')){element.src='https://www.runoob.com/images/pic_bulboff.gif';}"
	          "else{element.src='https://www.runoob.com/images/pic_bulbon.gif';}}"
            "</script>";
    html += "</body></html>";
    request->send(200, "text/html", html);
  });

  server.on("/toggle", HTTP_GET, [](AsyncWebServerRequest *request){
    digitalWrite(ledPin, !digitalRead(ledPin));
    bool ck = digitalRead(ledPin);
    if(ck){
      Serial.write(0x30); // 发送 ASCII 字符 '0'
    }else{
      Serial.write(0x31); // 发送 ASCII 字符 '1'
    }
    // bool ledState = !digitalRead(ledPin);
    // digitalWrite(ledPin, ledState);
    // Serial.print(ledState);

    String ledStatus = digitalRead(ledPin) ? "ON" : "OFF";
    request->send(200, "text/plain", "LED: " + ledStatus);

    // Serial.write(0x30); // 发送 ASCII 字符 '0'
    // Serial.write(0x31); // 发送 ASCII 字符 '1'
  });

  server.begin();
}

void loop() {
  
}